// Generated by CoffeeScript 1.12.6
var createFileWriter, exports, fs, moment, path, util,
  slice = [].slice;

path = require('path');

fs = require('fs');

util = require('util');

moment = require('moment');

createFileWriter = function(conf) {
  var _appendToFile, _formatLog, _formatSentence, _getFilepath, _writer, bufLogs, lock, truncated;
  if (conf == null) {
    conf = {};
  }
  truncated = false;
  lock = false;
  bufLogs = [];
  _getFilepath = function(file_ymd) {
    return path.join(conf.dir, ("" + file_ymd) + conf.postfix);
  };
  _formatLog = function() {
    var log_args, strs;
    log_args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    if (Array.isArray(log_args[0])) {
      return _formatSentence(log_args[0]);
    }
    strs = log_args.map(function(x) {
      return x.toString();
    });
    return strs.join(' ') + '\n';
  };
  _formatSentence = function(log_sentence_ml) {
    var _x, actor, anotate_str, attr, attrs, child, childs, dt, dump, dump_item, el_type, fmt_txt, i, j, k, len, len1, len2, line, oth, story, str, tag, text, time, value, word;
    tag = log_sentence_ml[0], attr = log_sentence_ml[1], childs = 3 <= log_sentence_ml.length ? slice.call(log_sentence_ml, 2) : [];
    if (tag !== 'log_sentence') {
      throw new Error('Wrong Json ML data');
    }
    actor = null;
    story = [];
    dump = [];
    for (i = 0, len = childs.length; i < len; i++) {
      child = childs[i];
      if (Array.isArray(child)) {
        el_type = child[0], oth = 2 <= child.length ? slice.call(child, 1) : [];
        if (el_type === 'subject') {
          actor = child;
        }
        if (el_type === 'text') {
          story.push(child);
        }
        if (el_type === 'var') {
          dump.push(child);
        }
      } else {
        story.push(['text', null, child]);
      }
    }
    line = [];
    time = moment(attr.when);
    dt = time.format("hh:mm:ss.SSSS");
    line.push("[" + dt + "]");
    if (actor) {
      line.push('[' + actor.join(':') + ']');
    }
    for (j = 0, len1 = story.length; j < len1; j++) {
      word = story[j];
      _x = word[0], attrs = word[1], str = word[2];
      if (attrs) {
        anotate_str = JSON.stringify(attrs);
        line.push("[" + str + "](" + anotate_str + ")");
      } else {
        line.push(str);
      }
    }
    text = line.join(' ');
    fmt_txt = text + "\n";
    for (k = 0, len2 = dump.length; k < len2; k++) {
      dump_item = dump[k];
      _x = dump_item[0], attrs = dump_item[1], value = dump_item[2];
      fmt_txt += "  " + attrs.name + " => " + value + "\n";
    }
    return fmt_txt;
  };
  _appendToFile = function() {
    var attrs, data_to_fs, el_type, els, file_ymd, filepath, log_args, ref, time, ymd;
    if (lock) {
      return;
    }
    if (bufLogs.length === 0) {
      return;
    }
    lock = true;
    data_to_fs = '';
    file_ymd = null;
    while (true) {
      if (bufLogs.length === 0) {
        break;
      }
      log_args = bufLogs[0];
      if (Array.isArray(log_args[0])) {
        ref = log_args[0], el_type = ref[0], attrs = ref[1], els = 3 <= ref.length ? slice.call(ref, 2) : [];
        time = moment(attrs.when);
        ymd = time.format("YYYYMMDD");
      } else {
        ymd = moment().format("YYYYMMDD");
      }
      if (file_ymd !== null && file_ymd !== ymd) {
        break;
      }
      file_ymd = ymd;
      bufLogs.shift();
      data_to_fs += _formatLog.apply(null, log_args);
    }
    filepath = _getFilepath(file_ymd);
    return fs.appendFile(filepath, data_to_fs, function(err) {
      lock = false;
      return _appendToFile();
    });
  };
  return _writer = function() {
    var log_args;
    log_args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    bufLogs.push(log_args);
    return _appendToFile();
  };
};

module.exports = exports = createFileWriter;
