// Generated by CoffeeScript 1.12.6
var EpicLog, _isString, exports, filter_factory, writer_factory, writers,
  slice = [].slice,
  hasProp = {}.hasOwnProperty;

_isString = function(obj) {
  return typeof obj === 'string' || obj instanceof String;
};

writers = {};


/*

Json ML 규격으로 하자. 그래야 Stream너머로 보내기에 유리함.

[ "log_sentence", 
{
  pid = pid,
  when = ISODateString
  사용자 attrs...
}
["subject", "scope1", ... ]
["story", literal, ["string", attr, string ...], ... ] 
["dump", [key, value], [type, string, ...], ... ] 
]


입력 가능은..
  1. Strings... 
  2. JsonML
  3. Class Instance..? (이거 너무 의존적.. ) 그러니 JsonML로..
 */

EpicLog = function() {
  var _write_fn, filter_def, json_ml, k, log_args, ref, results;
  log_args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
  results = [];
  for (k in writers) {
    if (!hasProp.call(writers, k)) continue;
    ref = writers[k], filter_def = ref[0], _write_fn = ref[1];
    if (Array.isArray(log_args[0])) {
      json_ml = log_args[0];
      if (filter_def && EpicLog.filtering) {
        if (true !== EpicLog.filtering(json_ml, filter_def)) {
          continue;
        }
      }
    }
    results.push(_write_fn.apply(null, log_args));
  }
  return results;
};

EpicLog.conf = {};

writer_factory = {};

EpicLog.addWriterFactory = function(key, factory_fn) {
  return writer_factory[key] = factory_fn;
};

filter_factory = {};

EpicLog.addFilterFactory = function(key, factory_fn) {
  return filter_factory[key] = factory_fn;
};

EpicLog.setWriter = function(key, filter_def, sub_writer) {
  writers[key] = [filter_def, sub_writer];
  if (!sub_writer) {
    return delete writers[key];
  }
};

EpicLog.getWriter = function(key) {
  return writers[key][1];
};

EpicLog.getFilter = function(key) {
  return writers[key][0];
};

EpicLog.addWriterFactory('vt', require('./vt-writer'));

EpicLog.addWriterFactory('file', require('./file-writer'));

module.exports = exports = EpicLog;
