// Generated by CoffeeScript 1.12.6
var chalk, color_candidates, createVTWriter, exports, moment, shuffleArray,
  slice = [].slice;

moment = require('moment');

shuffleArray = function(a) {
  var i, j, x;
  i = a.length;
  while (i) {
    j = Math.floor(Math.random() * i);
    x = a[i - 1];
    a[i - 1] = a[j];
    a[j] = x;
    i--;
  }
  return a;
};

chalk = require('chalk');

color_candidates = "red,green,yellow,blue,magenta,cyan";

color_candidates = shuffleArray(color_candidates.split(','));

createVTWriter = function(conf) {
  var _formatSentence, _writer, colored, keyword_color_table, next_candidate;
  if (conf == null) {
    conf = {};
  }
  next_candidate = 0;
  keyword_color_table = {};
  colored = function(section) {
    var clr;
    if (!keyword_color_table[section]) {
      keyword_color_table[section] = color_candidates[next_candidate];
      next_candidate++;
      if (next_candidate === color_candidates.length) {
        next_candidate = 0;
      }
    }
    clr = keyword_color_table[section];
    return chalk.bold[clr](section);
  };
  _formatSentence = function(log_sentence_ml) {
    var _x, actor, attr, attrs, child, childs, dt, dump, dump_item, el_type, k, l, len, len1, len2, line, lines, m, ns, oth, story, str, tag, text, time, value, word;
    tag = log_sentence_ml[0], attr = log_sentence_ml[1], childs = 3 <= log_sentence_ml.length ? slice.call(log_sentence_ml, 2) : [];
    if (tag !== 'log_sentence') {
      throw new Error('Wrong Json ML data');
    }
    actor = null;
    story = [];
    dump = [];
    for (k = 0, len = childs.length; k < len; k++) {
      child = childs[k];
      if (Array.isArray(child)) {
        el_type = child[0], oth = 2 <= child.length ? slice.call(child, 1) : [];
        if (el_type === 'subject') {
          actor = child;
        }
        if (el_type === 'text') {
          story.push(child);
        }
        if (el_type === 'var') {
          dump.push(child);
        }
      } else {
        story.push(['text', null, child]);
      }
    }
    line = [];
    time = moment(attr.when);
    dt = time.format("hh:mm:ss.SSSS");
    line.push("[" + dt + "]");
    line.push(colored(attr.pid));
    if (actor) {
      ns = actor.map(function(scope) {
        return colored(scope);
      });
      line.push('[' + ns.join(':') + ']');
    }
    for (l = 0, len1 = story.length; l < len1; l++) {
      word = story[l];
      _x = word[0], attr = word[1], str = word[2];
      if (attr) {
        str = chalk.bold(str);
        if (attr.color != null) {
          str = chalk[attr.color](str);
        }
        if (attr.keyword === true) {
          str = colored(str);
        }
      }
      line.push(str);
    }
    text = line.join(' ');
    lines = [];
    lines.addLine = function() {
      var args;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      return lines.push(args);
    };
    lines.addLine(text);
    for (m = 0, len2 = dump.length; m < len2; m++) {
      dump_item = dump[m];
      _x = dump_item[0], attrs = dump_item[1], value = dump_item[2];
      if (attrs.type === 'error') {
        value = chalk.bold.red(value);
      }
      lines.addLine((chalk.bold.cyan(attrs.name)) + " =>", value);
    }
    return lines;
  };
  return _writer = function() {
    var k, len, lines, ln, log_args, results;
    log_args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    if (Array.isArray(log_args[0])) {
      lines = _formatSentence(log_args[0]);
    } else {
      lines = [
        log_args.map(function(x) {
          return x.toString();
        })
      ];
    }
    results = [];
    for (k = 0, len = lines.length; k < len; k++) {
      ln = lines[k];
      results.push(console.log.apply(console, ln));
    }
    return results;
  };
};

module.exports = exports = createVTWriter;
